#!/vol/pub/PQTcl/bin/tclsh

#Usage: HTCLtoTCL.tcl input-file.htcl > outputfile.tcl

set f [open [lindex $argv 0] r]
set HTCLlibraries /home/k2/users/clarsen/htcl

set sc [scancontext create]
set lines {}
set state tcl

scanmatch -nocase $sc {^##HTML ([^ ]+)} {
    global section
    global state
    set section $matchInfo(submatch0)
    if {$state!="tcl"} {
	error "##missing endhtml"
    }
    set state html

    puts "global cursection"
    puts "lvarpush cursection \"$section\""
    puts "##begin html $section"
}

scanmatch -nocase $sc {^##HTML[ ]*$} {
    global section
    global state
    set section main
    if {$state!="tcl"} {
	error "##missing endhtml"
    }
    set state html
    puts "global cursection"
    puts "lvarpush cursection \[lindex \$cursection 0\]"
    puts "##begin html current section"
}

scanmatch -nocase $sc {^##popsection[ ]*$} {
    global section
    global state
    
    puts "global cursection"
    puts "lvarpop cursection 0"
    puts "##end current section"
}

scanmatch -nocase $sc {^##ENDHTML NOPOP} {
    global state
    global section
    global lines
    #output remaining lines
    foreach i $lines {
	puts "  AppendComponent \[lindex \$cursection 0\] \[HTMLtxt #auto -txt \"$i\"\]"
    }
    set lines {}

    puts "##end html $section"
    set state tcl
}

scanmatch -nocase $sc {^##ENDHTML[ ]*$} {
    global state
    global section
    global lines
    #output remaining lines
    foreach i $lines {
	puts "  AppendComponent \[lindex \$cursection 0\] \[HTMLtxt #auto -txt \"$i\"\]"
    }
    set lines {}

    puts "global cursection"
    puts "lvarpop cursection 0"
    puts "##end html $section"
    set state tcl
}

scanmatch -nocase $sc {^##SECTION ([^ ]+)} {
    global state
    global section
    global lines
    if {$state!="html"} {
	error "##SECTION not in html"
    } else {
	puts "##output html"
	puts "global cursection"
	foreach i $lines {
	    puts "  AppendComponent \[lindex \$cursection 0\] \[HTMLtxt #auto -txt \"$i\"\]"
	}
	set lines {}
    }
    set sec $matchInfo(submatch0)
    puts "##add section $sec to current section"
    puts "  AppendComponent \[lindex \$cursection 0\] \[GetComp $sec\]"
}

proc quotequote {v} {
    regsub -all {"} $v {\"} v
    return $v
}

scanmatch -nocase $sc {^##PROLOGUE} {
puts "##PROLOGUE"
puts "set cursection {main}"
puts "lappend auto_path $HTCLlibraries"

puts "set curdocument \[HTMLDocument #auto\]"
puts "InitDocument \$curdocument"
}

scanmatch -nocase $sc {^##OUTHTML ([^ ]*)} {
puts "##OUTPUT HTML"
puts "global curdocument"
puts "\$curdocument write $matchInfo(submatch0)"
}

scanmatch $sc {
    global state
    global section
    global lines
    set line $matchInfo(line)
    if {$state=="tcl"} {
	puts $line
    } else {

	lappend lines [quotequote $line]
#	puts "##append line"
    }
}

scanfile $sc $f
