#!/vol/pub/PQTcl/bin/tclsh

lappend auto_path /home/ux6/ux6c/opern/clarsen/public_html/projects/htcl

if [info exists env(REMOTE_HOST)] {
   http_proc_cgi_args
}

##PROLOGUE
set cursection {main}
lappend auto_path /home/k2/users/clarsen/htcl
set curdocument [HTMLDocument #auto]
InitDocument $curdocument


# Sections  can be defined at a later time, possibly from within a function
# like this:

proc titlesection {section text} {
global cursection
lvarpush cursection "$section"
##begin html $section
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "<h2>$text</h2>"]
global cursection
lvarpop cursection 0
##end html $section
}

# Default section of main:

global cursection
lvarpush cursection [lindex $cursection 0]
##begin html current section
##output html
global cursection
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "<TITLE>This is the title</TITLE>"]
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "<h1>This is the first level header</h1>"]
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt ""]
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "This is some text before section1<p>"]
##add section section1 to current section
  AppendComponent [lindex $cursection 0] [GetComp section1]
global cursection
lvarpop cursection 0
##end html main

# TCL processing here

#We add all environment and query argument information to section 1.

titlesection section1 "Section 1"
global cursection
lvarpush cursection "section1"
##begin html section1
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "<ul>"]
global cursection
lvarpop cursection 0
##end html section1

#print query arguments if present
if [info exists ar] {
  foreach  i [array names ar] {
global cursection
lvarpush cursection "section1"
##begin html section1
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "<li> $i = $ar($i)"]
global cursection
lvarpop cursection 0
##end html section1
  }
}

#print environment variables
foreach i [array names env] {
global cursection
lvarpush cursection "section1"
##begin html section1
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "<li> env($i) = $env($i)"]
global cursection
lvarpop cursection 0
##end html section1
}

global cursection
lvarpush cursection "section1"
##begin html section1
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "</ul>"]
global cursection
lvarpop cursection 0
##end html section1

#Continue document

set abc section2

global cursection
lvarpush cursection [lindex $cursection 0]
##begin html current section
##output html
global cursection
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "This is some text between section1 and $abc<p>"]
##add section $abc to current section
  AppendComponent [lindex $cursection 0] [GetComp $abc]
  AppendComponent [lindex $cursection 0] [HTMLtxt #auto -txt "This is some text after section and $abc."]
global cursection
lvarpop cursection 0
##end html main

# We aren't making full use of the sectioning capabilities.  In actual
# practice, sections would contain lots of related data (and possibly
# subsections.)
titlesection section2 "Section 2"

#Finally show the document

##OUTPUT HTML
global curdocument
$curdocument write stdout
# more TCL processing, or usually, just exit at this point.
